=== debian/changelog ===
vimix (0.7.2+git20221123+ds-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:31:10 +1100

vimix (0.7.2+git20221123+ds-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:56:40 +0000

vimix (0.7.2+git20221123+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with gcc 13. (Closes: #1037883)

 -- Boyuan Yang <byang@debian.org>  Fri, 12 Jan 2024 10:12:23 -0500

vimix (0.7.2+git20221123+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/install: updated.
  * Bump standards version to 4.6.1.
  * d/copyright: added Files-Excluded field.

 -- Gürkan Myczko <tar@debian.org>  Wed, 23 Nov 2022 15:35:12 +0100
