=== debian/control ===
Source: vimix
Section: video
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 ableton-link-dev,
 cmake,
 fonts-roboto-unhinted, fonts-hack,
 gstreamer1.0-libav,
 libpng-dev,
 libglfw3-dev,
 libgstreamer1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libicu-dev,
 libglm-dev,
 libgtk-3-dev,
 libstb-dev,
 libtinyxml2-dev
Standards-Version: 4.6.1
Homepage: https://brunoherbelin.github.io/vimix/
Vcs-Browser: https://salsa.debian.org/multimedia-team/vimix
Vcs-Git: https://salsa.debian.org/multimedia-team/vimix.git
Rules-Requires-Root: no

Package: vimix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 fonts-roboto-unhinted, fonts-hack
Description: Live Video Mixer
 This performs graphical mixing and blending of several movie clips and computer
 generated graphics, with image processing effects in real-time.
 .
 Its intuitive and hands-on user interface gives direct control on image opacity
 and shape for producing live graphics during concerts and VJ-ing sessions.
 .
 The output image is typically projected full-screen on an external monitor or a
 projector, but can be recorded live (no audio).
